#include "common.hh"
#include "ground.hh"
#include "params.hh"

GroundPlane::GroundPlane (double pos): dist_(pos) {}

const void GroundPlane::inside (Vector& point, const Vector& old) const {
  if (point.z() < dist_) {
    double lambda = (dist_-old.z())/(point.z()-old.z()-EPSILON);
    point = old + lambda*(point-old);
  }
}

const void GroundPlane::adjust (Vector& force, const Vector& point) const {
  if (point.z() <= dist_+EPSILON) {
    if (force.z() < 0)
      force.z(0);
    Vector tmp = force;
    tmp.z(0);
    double l = tmp.length();
    if (l < (friction + EPSILON))
      force -= tmp;
    else
      force -= (friction/l)*tmp;
  }
}
