#ifndef VECTOR_HH
#define VECTOR_HH

#include <iostream>

class Vector {
private:
  double coords[3];

  mutable double l_;

public:
  Vector (double x=0, double y=0, double z=0);
  Vector (const Vector&);

  const Vector operator+ (const Vector&) const;
  const Vector operator+() const;
  const Vector operator- (const Vector&) const;
  const Vector operator-() const;

  Vector& operator+= (const Vector&);
  Vector& operator-= (const Vector&);
  Vector& operator*= (const double);

  friend const Vector operator* (const double, const Vector&);

  friend ostream& operator<< (ostream& o, const Vector&);

  const bool operator== (const Vector&) const;

  inline const double x() const { return coords[0]; }
  inline const double y() const { return coords[1]; }
  inline const double z() const { return coords[2]; }
  inline void x (double v) { l_ = -1; coords[0] = v; }
  inline void y (double v) { l_ = -1; coords[1] = v; }
  inline void z (double v) { l_ = -1; coords[2] = v; }

  const double length() const;
  const Vector normalize() const;
  const double dot (const Vector&) const;
  const Vector cross (const Vector&) const;
};

extern const Vector O, X, Y, Z;
#else

class Vector;

#endif
